 <!DOCTYPE html>

<html>
<head>
<link href="https://fonts.googleapis.com/css?family=Shrikhand" rel="stylesheet">
<meta charset="utf-8" />
<title>ChillGame</title>
<style>
    * { padding: 0; margin: 0; }
    canvas { background:linear-gradient(to bottom, #ff9068, #fd746c); display: block; margin: 0 auto;}       
</style>
</head>
<body ontouchstart="showCoordinates(event)" ontouchmove="showCoordinates(event)" ontouchend="releaseTouch()">

<canvas id="myCanvas" width="480" height="700" style="font-family: 'Shrikhand', cursive; font-size: 30px;"></canvas>

<script>
    
let canvas = document.getElementById("myCanvas");
let ctx = canvas.getContext("2d");
let rightPressed = false;
let leftPressed = false;
 

function resize() {
    let width;
    let height;
    
    if (window.innerHeight > window.innerWidth){
        let ratio = 1334/750;
        width = window.innerWidth;
        height = width*ratio;
        console.log("portrait screen");
    }
    else{
        let ratio = 1.618;
        canvas.style.marginBottom = "50px";
        canvas.style.marginTop = "50px";
        height = window.innerHeight - 100;
        width = height/ratio;
        console.log("landscape screen");
    }

	canvas.style.width = width+'px';
	canvas.style.height = height+'px';
    
}
    
window.addEventListener('load', resize, false);
window.addEventListener('resize', resize, false);
canvas.addEventListener("mousemove", mouseMoveHandler, false);
document.addEventListener("keyup", keyUpHandler, false);
document.addEventListener("keydown", keyDownHandler, false);
//document.addEventListener("touchstart", showCoordinates, false);


function showCoordinates(event){
    var x = event.touches[0].clientX;
    
    if (x < window.innerWidth && x > (window.innerWidth)/2) {
        rightPressed = true;
    }
    if (x < (window.innerWidth)/2 && x > 0){
        leftPressed = true;
    }
}


function releaseTouch(){
    rightPressed = false;
    leftPressed = false;
}


function mouseMoveHandler(e) {
    var relativeX = e.clientX - canvas.offsetLeft;
    if(relativeX > (mouth.width)/2 && relativeX < canvas.width-(mouth.width)/2) {
        mouth.position = relativeX - (mouth.width)/2;
    }
}


function keyDownHandler(e) {
    if(e.keyCode == 39) {
        rightPressed = true;
    }
    else if(e.keyCode == 37) {
        leftPressed = true;
    }
}


function keyUpHandler(e) {
    if(e.keyCode == 39) {
        rightPressed = false;
    }
    else if(e.keyCode == 37) {
        leftPressed = false;
    }
}
    
// Shadow for text
ctx.shadowOffsetX = 3;
ctx.shadowOffsetY = 3;
ctx.shadowColor = "rgba(0,0,0,0)";
ctx.shadowBlur = 4;

// Mouth variables and associated function:
let mouth = {
    height : 20,
    width : 120,
    position : (canvas.width-this.width)/2,
    drawMouth: function(){
        ctx.beginPath();
        ctx.rect(this.position, canvas.height-this.height, this.width, this.height);
        let grad = ctx.createLinearGradient(this.position, canvas.height - this.height, this.position, canvas.height + 50);
        grad.addColorStop(0, "#c9d6ff");
        grad.addColorStop(1, "#5B86E5");
        ctx.fillStyle = grad;
        ctx.fill();
        ctx.closePath();
    }
};
    
// Ball variables
let ballRadius = 12;
let dy = 2;

let score = 0;


function sinPattern(width_stretch, height_stretch, number_of_balls) {
    coord_array = [];
    for (var i = 0; i < number_of_balls; i++){

        let pos_ninety_deg = Math.PI/2;
        let neg_ninety_deg = -Math.PI/2;

        let x_pos = width_stretch*Math.sin(pos_ninety_deg/4*i)+canvas.width/2;
        coord_array.push({x : x_pos, y : -i*height_stretch, status : 1});
    }
    return coord_array;
}


function drawRoundOne(){
    sinPattern(120, 40, 64);
}


function drawScore() {
    ctx.shadowColor = "rgba(0,0,0,0.3)";
    ctx.font = "45px Shrikhand";
    ctx.fillStyle = "#c9d6ff";
//  let height = parseInt(ctx.font.match(/\d+/), 10);
    let height = parseInt(ctx.font);
    ctx.fillText("Score: " + score, 10, height);
    ctx.shadowColor = "rgba(0,0,0,0)";
}


function drawFinalScore(final_score) {
    ctx.shadowColor = "rgba(0,0,0,0.3)";
    ctx.font = "60px Shrikhand";
    ctx.fillStyle = "#c9d6ff";
    
    let height = parseInt(ctx.font)
    text = "Score: " + final_score.toString();
    ctx.fillText("Well Done!", canvas.width/2-ctx.measureText("Well Done!").width/2, canvas.height/2);
    ctx.fillText(text, canvas.width/2-ctx.measureText(text).width/2, canvas.height/2 + height);
    
    ctx.shadowColor = "rgba(0,0,0,0)";
}


function animateGame(){
    for (var c = 0; c < coord_array.length; c++){
        coord_array[c].y += dy;
        
        // When any part of the ball is on the canvas, draw it:
        if(coord_array[c].y + ballRadius > 0 && coord_array[c].y - ballRadius < canvas.height && coord_array[c].status === 1){
            ctx.beginPath();
            ctx.arc(coord_array[c].x, coord_array[c].y, ballRadius, 0, Math.PI*2);
            ctx.fillStyle = "#c9d6ff";
            ctx.fill();
            ctx.closePath();
        }
        
        // Circular gradient:
        //            let grad = ctx.createRadialGradient(coord_array[c].x, coord_array[c].y, 5, coord_array[c].x, coord_array[c].y, ballRadius+5)
        //            grad.addColorStop(0, "#c9d6ff");
        //            grad.addColorStop(1, "#5B86E5");
        //            ctx.fillStyle = grad;
        
        
        // When the ball goes in the mouth, make mouth smaller, add to score and change status:
        if(coord_array[c].y + ballRadius > (canvas.height - mouth.height) && coord_array[c].x > mouth.position && coord_array[c].x < mouth.position + mouth.width && coord_array[c].status === 1){
            score++;
            if(mouth.width >= 50){
                mouth.width -= 5;
            }
            coord_array[c].status = 0;
        }
        
        // When the top of ball drops below the bottom of the canvas and mouth has been missed, make mouth bigger and change status:
        if(coord_array[c].y - ballRadius > canvas.height && coord_array[c].status === 1){
            if(mouth.width < 100){
                mouth.width += 5;
            }
            coord_array[c].status = 0;
        }
    }
    
    // Get rid of balls that have gone below the canvas (i.e. with status 0) from the array of coordinates:
    for (var c = 0; c < coord_array.length; c++){
        if(coord_array[c].status === 0){
            coord_array.splice(c, 1); //removes the element at index c, the 1 means just remove one element
        }
    }
    
    // When all balls dropped below canvas, display final score:
    if (coord_array.length === 0) {
        drawFinalScore(score);
    }
}

mouth.position = (canvas.width-mouth.width)/2;

function draw() {
    ctx.clearRect(0, 0, canvas.width, canvas.height);
    drawScore();
    // mouth.position = event.touches[0].clientX;
    mouth.drawMouth();
    animateGame();
    
    
    if(rightPressed && mouth.position < canvas.width-mouth.width) {
        mouth.position += 3;
    }
    else if(leftPressed && mouth.position > 0) {
        mouth.position -= 3;
    }

    // requestAnimationFrame(draw)

}
drawRoundOne();

setInterval(draw, 10)
draw();




</script>

</body>
</html>
